SystemOrganization addCategory: #'SqueakIt-Experiments-RJG'!
SystemOrganization addCategory: #'SqueakIt-Experiments-RJG-Tests'!
SystemOrganization addCategory: #SqueakIt!
SystemOrganization addCategory: #'SqueakIt-StringManipulation'!

TestCase subclass: #RootComponentTest
	instanceVariableNames: 'module html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt-Experiments-RJG-Tests'!

!RootComponentTest methodsFor: 'accessing' stamp: 'RonnieGarduno 1/29/2013 17:32'!
html
	^ html! !

!RootComponentTest methodsFor: 'accessing' stamp: 'RonnieGarduno 1/29/2013 17:32'!
html: anObject
	html := anObject! !

!RootComponentTest methodsFor: 'accessing' stamp: 'RonnieGarduno 1/29/2013 17:32'!
module
	^ module! !

!RootComponentTest methodsFor: 'accessing' stamp: 'RonnieGarduno 1/29/2013 17:32'!
module: anObject
	module := anObject! !

!RootComponentTest methodsFor: 'running' stamp: 'RonnieGarduno 1/29/2013 17:42'!
setUp 
	module := RootComponent new.
	html := WAHtmlCanvas new! !

!RootComponentTest methodsFor: 'tests' stamp: 'RonnieGarduno 1/29/2013 17:33'!
testHasTitle
	self shouldnt: [module title] raise: Error.
	self module renderContentOn: html.
"	self assert: html notNil"! !

!RootComponentTest methodsFor: 'tests' stamp: 'RonnieGarduno 1/29/2013 15:45'!
testSetTitleChanges
	module title: 'testing'.
	self assert: module title = 'testing'.
	module title: 'new'.
	self assert: (module title = 'testing') not.
	self assert: module title = 'new'! !

!RootComponentTest methodsFor: 'tests' stamp: 'RonnieGarduno 1/29/2013 15:43'!
testSetTitleSets
	module title: 'testing'.
	self assert: module title = 'testing'! !

WATask subclass: #SIRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt'!

!SIRootTask class methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:21'!
canBeRoot 

	^ true! !

!SIRootTask class methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:21'!
initialize

	(WAAdmin
		register: self
		asApplicationAt: 'SqueakIt')
		addLibrary: PTDevelopmentLibrary;
		addLibrary: SUDevelopmentLibrary;
		addLibrary: SILibrary;
		preferenceAt: #sessionClass put: SISession.! !

!SIRootTask methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:37'!
go

	| loginAnswer user |
	loginAnswer := self call: SILoginComponent new.
	loginAnswer = #registerUser
		ifTrue: [user := self call: SIRegisterComponent new]
		ifFalse: [user := loginAnswer].
	user ifNotNil: [
		self session login: user.
		self call: SIRootComponent new].
! !

WAFileLibrary subclass: #SILibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt'!

!SILibrary class methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:26'!
applicationName 
	^ 'SqueakIt'! !

!SILibrary methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/11/2013 19:18'!
moduleCss
	^ '
	
body {
	font: normal 100% Arial, Helvetica, Verdana, sans-serif;
	
/* IE10 Consumer Preview */ 
background-image: -ms-linear-gradient(top left, #111150 0%, #000A0A 100%);

/* Mozilla Firefox */ 
background-image: -moz-linear-gradient(top left, #111150 0%, #000A0A 100%);

/* Opera */ 
background-image: -o-linear-gradient(top left, #111150 0%, #000A0A 100%);

/* Webkit (Safari/Chrome 10) */ 
background-image: -webkit-gradient(linear, left top, right bottom, color-stop(0, #111150), color-stop(1, #000A0A));

/* Webkit (Chrome 11+) */ 
background-image: -webkit-linear-gradient(top left, #111150 0%, #000A0A 100%);

/* W3C Markup, IE10 Release Preview */ 
background-image: linear-gradient(to bottom right, #111150 0%, #000A0A 100%);
	
	text-align: center;
 	text-shadow: 1px 1px 2px rgba(0,0,0,0.6);
	text-decoration: none;
	padding: 5px 10px;
	border-radius: 15px;
	border: 3px solid rgb(0,0,0);
}
	
 .module{
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-style: normal;
	font-weight: normal;
	font-size: 14px;
	color : #F0F0F0;
	padding: 20px;
	margin-top: 20px;
	margin-left: 20px;
	width: 500px;
}

.lightbox {
	background-color:#FFFFFF;
}

.errorMessage {
	background-color: #ffb0b0;
	border: 1px solid #ee0000;
	padding: 5px;
	margin-bottom: 10px;
}

.infoMessage {
	background-color: #fbffcc;
	border: 1px solid #eda33a;
	padding: 5px;
	margin-bottom: 10px;
}

a {
	color : teal;
	text-decoration: underline;
}

.objectives{
		background-color: grey;
		width: 200px;
		height: 125px;
		margin-left: 200px;
		margin-top: 50px;
		margin-bottom: 50px;
		padding-left: 15px;
		text-align: left;
		color: lavender;
		border-width: 2px;
		border-color: black;
		border-style: ridge;
	}
	
	#links{
		text-align: left;
		color: purple;
		background-color: lightGray;
		position: fixed;
		top: 200px;
		left: 15px;
		margin-left: 10px;
		padding-right: 50px;
		padding-top: 50px;
		padding-bottom: 50px;
		padding-left: 20px;
		border-radius: 15px;
		border-width: 3px;
		border-style: solid;
		border-color: #000;
	}
	
		.title{
		color: red;
		text-align: left;
		margin-left: 10px;
		position: fixed;
		top: 150px;
		left: 20px;
	}
	
	div#images{
		left: 600px;
		width: 300px;
		position: relative;
	}
	h1{
	font-style: normal;
	color : #F0F0F0;
	padding: 20px;
	margin-top: 20px;
	margin-left: 0px;
	margin-right: 40px;
	width: 200px;
	font-size: 36px;
	font-family: Georgia;
	}
	.text{
	font-style: normal;
	color : #F0F0F0;
	padding: 20px;
	margin-top: 20px;
	margin-left: 20px;
	width: 500px;
	font-size: 36px;
	}
	#connections{
		width: 300px;
		height: 30px;
		margin-left: 150px;
		background-color: lightGray;
	}
	hr{
		width: 800px;
	}
'! !

!SILibrary methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 16:09'!
selectorsToInclude 
	^ #( moduleCss )
	! !

WAComponent subclass: #RootComponent
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt-Experiments-RJG'!

!RootComponent class methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 1/29/2013 17:07'!
canBeRoot 
	^true! !

!RootComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 1/29/2013 17:11'!
initialize 
	super initialize.
	title := 'Hello Internet!!'! !

!RootComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 1/29/2013 17:41'!
renderContentOn: html
	html heading: title.
	html text: 'This will one day be a mighty website.'.
	html break.
	html text: html class.
	html break.! !

!RootComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 1/28/2013 17:38'!
title
	^ title! !

!RootComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 1/28/2013 17:38'!
title: anObject
	title := anObject! !

WAComponent subclass: #SIDialogComponent
	instanceVariableNames: 'msg video'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt'!

!SIDialogComponent methodsFor: 'initialization' stamp: 'B.C. 2/2/2013 10:41'!
initialize
	super initialize.
	msg := 'None'! !

!SIDialogComponent methodsFor: 'accessing' stamp: 'B.C. 2/1/2013 08:20'!
msg
	^ msg! !

!SIDialogComponent methodsFor: 'accessing' stamp: 'B.C. 2/1/2013 08:20'!
msg: aString
	msg := aString! !

!SIDialogComponent methodsFor: 'rendering' stamp: 'B.C. 2/9/2013 11:23'!
renderContentOn: html
	html text: msg.
	html break.
	html break.
	
	html submitButton
		onClick: (html javascript return: (JSStream on: 'window.close();'));
		with: 'Close Window'! !

!SIDialogComponent methodsFor: 'accessing' stamp: 'B.C. 2/1/2013 09:01'!
video
	^ video! !

!SIDialogComponent methodsFor: 'accessing' stamp: 'B.C. 2/1/2013 09:01'!
video: anObject
	video := anObject! !

WAComponent subclass: #SILoginComponent
	instanceVariableNames: 'email password messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt'!

!SILoginComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:27'!
applicationName

	^ SILibrary applicationName ! !

!SILoginComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:18'!
email
	^ email! !

!SILoginComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:18'!
email: anObject
	email := anObject! !

!SILoginComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:18'!
hashPassword: aString

	aString 
		ifEmpty: [^ 0] 
		ifNotEmpty: [^ SecureHashAlgorithm new hashMessage: aString].! !

!SILoginComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:18'!
initialize
	
	super initialize.! !

!SILoginComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:18'!
loginFailed

	self messageComponent errorMessage: 'Login failed.'.! !

!SILoginComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:18'!
loginSuccess

	self messageComponent infoMessage: 'Login was successful!!'.! !

!SILoginComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/11/2013 17:24'!
messageComponent
		^ messageComponent ifNil: [messageComponent := SIMessageComponent new]! !

!SILoginComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:18'!
messageComponent: anObject
	messageComponent := anObject! !

!SILoginComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:18'!
password
	^ password! !

!SILoginComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:18'!
password: anObject
	password := anObject! !

!SILoginComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:18'!
registerUser
	
	self answer: #registerUser.! !

!SILoginComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:28'!
renderContentOn: html

	html div
	class: 'generic';
	with: [
		html
			heading: 'SqueakIt';
			render: self messageComponent;
			text: 'Please login with e-mail and password:';
			form: [
				self
					renderTextInputOn: html;
					renderPasswordInputOn: html;
					renderLoginButtonOn: html;
					renderSignUpAnchorOn: html]].! !

!SILoginComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:18'!
renderLoginButtonOn: html

	html submitButton
		callback: [self validateLogin];
		text: 'Login'.! !

!SILoginComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:18'!
renderPasswordInputOn: html

	html passwordInput
		callback: [:value | self password: (self hashPassword: value)];
		value: ''.! !

!SILoginComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:18'!
renderSignUpAnchorOn: html

	html paragraph with: [html anchor
		callback: [self registerUser];
		with: [html text: 'Sign up for the ', self applicationName]].! !

!SILoginComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:18'!
renderTextInputOn: html

	html textInput
		on: #email of: self;
		value: ''.
	html space.! !

!SILoginComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:18'!
validateLogin

	| user |
	user := self session findUserByEmail: self email.
	(user notNil and: [user password = self password])
		ifTrue: [self answer: user]
		ifFalse: [self loginFailed].! !

WAComponent subclass: #SIMessageComponent
	instanceVariableNames: 'messageString messageType wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt'!

!SIMessageComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:20'!
errorMessage: aString

	self
		messageString: aString;
		messageType: 'error';
		wasShown: false.! !

!SIMessageComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:20'!
infoMessage: aString

	self
		messageString: aString;
		messageType: 'info';
		wasShown: false.! !

!SIMessageComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:20'!
initialize

	super initialize.
	self wasShown: true.! !

!SIMessageComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:20'!
messageString
	^ messageString! !

!SIMessageComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:20'!
messageString: anObject
	messageString := anObject! !

!SIMessageComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:20'!
messageType
	^ messageType! !

!SIMessageComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:20'!
messageType: anObject
	messageType := anObject! !

!SIMessageComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:20'!
renderContentOn: html

	self wasShown ifTrue: [^ self].
	html div
		class: self messageType, 'Message';
		with: self messageString.! !

!SIMessageComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:20'!
wasShown
	^ wasShown! !

!SIMessageComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:20'!
wasShown: anObject
	wasShown := anObject! !

WAComponent subclass: #SIModuleComponent
	instanceVariableNames: 'title index connections objectives text video graphics interactives links audio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt'!

!SIModuleComponent methodsFor: 'accessing' stamp: 'Aubin 2/9/2013 11:30'!
audio
	^ audio! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'Aubin 2/9/2013 11:30'!
audio: anObject
	audio := anObject! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
connections
	^ connections! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
connections: anObject
	connections := anObject! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
graphics
	^ graphics! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
graphics: anObject
	graphics := anObject! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
index
	^ index! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
index: anObject
	index := anObject! !

!SIModuleComponent methodsFor: 'initialization' stamp: 'RonnieGarduno 2/11/2013 19:05'!
initialize 
	super initialize.
	self
		title: 'Module 1';
		text: 'This is our text.';
		objectives: OrderedCollection new;
		links: OrderedCollection new;
		connections: OrderedCollection new.
	self links add: 'home' -> 'test1'; add: 'next' -> 'test2'.
	self objectives add: 'Learn Squeak';
					add: 'Learn Seaside';
					add: 'Write webpage'.
	self graphics: ((OrderedCollection new) add: 'http://seaside.st/styles/logo-plain.png'; yourself).
	self connections add: 'Home' -> []; add: 'Next' -> []; add: 'First' -> []; add: 'Last' -> [].
	self video: ((OrderedCollection new) add: 'https://dl.dropbox.com/u/80110478/TTS%20with%20EXO%20-%20%20DJ%20Got%20Us%20Falling%20In%20Love%20Again%20SMTOWN%20in%20TOKYO%20120805%201080P.webm'; yourself).
	self audio: ((OrderedCollection new) add: 'https://dl.dropbox.com/u/80110478/infernoplex.ogg'; yourself).! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
interactives
	^ interactives! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
interactives: anObject
	interactives := anObject! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
links
	^ links! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
links: anObject
	links := anObject! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
objectives
	^ objectives! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
objectives: anObject
	objectives := anObject! !

!SIModuleComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 2/11/2013 19:20'!
renderContentOn: html
	html div
		class: 'title';
		with: [(html heading: self title level: 2)]. 
	html break.
	html div
		class: 'objectives';
		with:[
			html heading: 'Objectives:' level: 3.
			html unorderedList: [
				self objectives do: [:objective |
				html listItem: objective.
		]]].
	html break.
	html div
		class: 'text';
		with: [html text: self text].
	html break.
	html div
		id: 'links';
		with: [self links do: [:link |
		html anchor onClick: (html javascript alert: (link value)); with: link key.
		html break.
		]].
	html div
		id: 'images';
		with:[
		self graphics do: [:image |
			html image url: image;
				onClick: ((html jQuery: #images) hide)
			]].
	html break.
	html div
		id: 'connections';
		with:[self connections do: [:connection | 
			html anchor onClick: (html javascript alert: (connection value)); with: connection key.
			html space.
			]].
	html break.
	html horizontalRule.
	html div
		id: 'video';
		with: [ self video do: [ :vid |
				html video
					url: vid;
					controls: ''.]
				].
	html break.
	html horizontalRule.
	html div
		id: 'audio';
		with: [ self audio do: [ :aud |
				html audio
					url: aud;
					controls: ''.]
				].! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
text
	^ text! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
text: anObject
	text := anObject! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
title
	^ title! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
title: anObject
	title := anObject! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
video
	^ video! !

!SIModuleComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:20'!
video: anObject
	video := anObject! !

WAComponent subclass: #SIRegisterComponent
	instanceVariableNames: 'user repeatedPassword messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt'!

!SIRegisterComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:31'!
hashPassword: aString
	
	aString 
		ifEmpty: [^ 0] 
		ifNotEmpty: [^ SecureHashAlgorithm new hashMessage: aString].! !

!SIRegisterComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:32'!
initialize

	super initialize.
	self 
		user: SIUser new.! !

!SIRegisterComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:33'!
messageComponent

	^ messageComponent ifNil: [messageComponent := SIMessageComponent new]! !

!SIRegisterComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:31'!
messageComponent: anObject
	messageComponent := anObject! !

!SIRegisterComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:31'!
registerUser
    
	self user userName isEmptyOrNil
		ifTrue: [^ self messageComponent infoMessage: 'Please choose a username!!'].
	self user email isEmptyOrNil
		ifTrue: [^ self messageComponent infoMessage: 'Please enter your e-mail address!!'].
	(self session findUserByEmail: self user email)
		ifNotNil: [^ self messageComponent errorMessage: 'The e-mail address is already registered!!'].
	self user password = 0
		ifTrue: [^ self messageComponent infoMessage: 'Please choose a password!!'].
	self user password = self repeatedPassword
		ifFalse: [^ self messageComponent infoMessage: 'Your repeated password does not match!!'].
	self session database addUser: self user.
	self answer: self user.! !

!SIRegisterComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:31'!
renderCancelButtonOn: html
	
	html submitButton
		callback: [self answer: nil];
		text: 'Cancel'.! !

!SIRegisterComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:38'!
renderContentOn: html

	html div
		class: 'generic';
		with: [
			html
				heading: 'Register';
				render: self messageComponent;
				form: [
					html table: [
						self
							renderUsernameTextInputOn: html;
							renderEmailTextInputOn: html;
							renderPasswordTextInputOn: html;
							renderRepeatedPasswordTextInputOn: html.
						html tableRow: [
							html
								tableData;
								tableData: [
									self renderSubmitButtonOn: html.
									html space.
									self renderCancelButtonOn: html]]]]].
	! !

!SIRegisterComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:31'!
renderEmailTextInputOn: html

	html tableRow: [
		html
			tableData: 'E-mail';
			tableData: [
				html textInput
					callback: [:value | self user email: value];
					value: self user email]].! !

!SIRegisterComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:31'!
renderPasswordTextInputOn: html
    
	html tableRow: [
		html
			tableData: 'Password';
			tableData: [
				html passwordInput
					callback: [:value | self user password: (self hashPassword: value)]]].! !

!SIRegisterComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:31'!
renderRepeatedPasswordTextInputOn: html
  
	html tableRow: [
		html
			tableData: 'Repeat password';
			tableData: [
				html passwordInput
					callback: [:value | self repeatedPassword: (self hashPassword: value)]]].! !

!SIRegisterComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:31'!
renderSubmitButtonOn: html

	html submitButton
		callback: [self registerUser];
		text: 'Register'.! !

!SIRegisterComponent methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:31'!
renderUsernameTextInputOn: html

	html tableRow: [
		html
		tableData: 'Username';
		tableData: [
			html textInput
				callback: [:value | self user userName: value];
				value: self user userName]].! !

!SIRegisterComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:31'!
repeatedPassword
	^ repeatedPassword! !

!SIRegisterComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:31'!
repeatedPassword: anObject
	repeatedPassword := anObject! !

!SIRegisterComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:31'!
user
	^ user! !

!SIRegisterComponent methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:31'!
user: anObject
	user := anObject! !

WAComponent subclass: #SIRootComponent
	instanceVariableNames: 'moduleComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt'!

!SIRootComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 11:23'!
initialize 
	super initialize.
	self moduleComponent: SIModuleComponent new.
! !

!SIRootComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:23'!
moduleComponent
	^ moduleComponent! !

!SIRootComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 11:23'!
moduleComponent: anObject
	moduleComponent := anObject! !

!SIRootComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 2/11/2013 19:01'!
renderContentOn: html
	| dlg |
	dlg := SIDialogComponent new.
	
	html heading
		with: SILibrary applicationName.
	
	html horizontalRule.
	html break.
	
	html div
		class: 'module';
		with: self moduleComponent.
	 
	html horizontalRule.
	html break.

	html popupAnchor
		name: 'popup';
		callback: [ 
			dlg msg: 'Popup works'.
			self session presenter call: dlg];
		extent: 350@350;
		with: 'Test popup'.

	html break.
	html break.

	html anchor
		onClick: (html javascript alert: 'Testing alert');
		with:'Test alert'.

	html break.
	html break.

	html anchor
		onClick: (html javascript confirm: 'Testing confirm');
		with:'Test confirm'.

	html break.
	html break.

	html anchor
		onClick: (html javascript refresh);
		with:'Refresh'.
	html break.
	html break.

	html popupAnchor
		name: 'popup';
		callback: [ 
			dlg msg: 'Are you enjoying SqueakIt, ', self session user userName, '?'.
			self session presenter call: dlg];
		extent: 350@350;
		with: 'A message for you'.
	
"	 html paragraph class: 'actions'; with: [
 	     #(show: hide: toggle: slideDown: slideUp: slideToggle: fadeIn: fadeOut: fadeToggle:) do: [ :selector |
  	       html anchor
   	         onClick: ((html jQuery: #seastar) 
    	           perform: selector
     	          with: 1 seconds);
      	      with: selector allButLast ] ].
	self renderSeastarOn: html "! !

!SIRootComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 2/9/2013 11:02'!
renderSeastarOn: html
 html paragraph id: 'seastar'; with: [
      html image
         altText: 'Seaside';
         url: 'http://seaside.st/styles/logo-plain.png']! !

WASession subclass: #SISession
	instanceVariableNames: 'user database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt'!

!SISession methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:22'!
database
	^ database! !

!SISession methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:22'!
database: anObject
	database := anObject! !

!SISession methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:22'!
findUserByEmail: anEmail

	^ self database findUserByEmail: anEmail! !

!SISession methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:39'!
initialize
	
	super initialize.
	self database: SISandstoneDatabase new.! !

!SISession methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:22'!
isLoggedIn

	^ self user notNil! !

!SISession methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:22'!
login: aUser
	
	self user: aUser.! !

!SISession methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:22'!
logout

	self user: nil.! !

!SISession methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:22'!
responseForRequest: aRequest

	self database connectionFailed
		ifTrue: [^ WAResponse new nextPutAll: 'No Database Connection'].
	^ super responseForRequest: aRequest! !

!SISession methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:22'!
unregistered

	self database disconnect.
	super unregistered.! !

!SISession methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:23'!
updateRoot: anHtmlRoot

	super updateRoot: anHtmlRoot.! !

!SISession methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:22'!
user
	^ user! !

!SISession methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:22'!
user: anObject
	user := anObject! !

SDActiveRecord subclass: #SIUser
	instanceVariableNames: 'userName email password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt'!

!SIUser methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:32'!
email
	^ email! !

!SIUser methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:32'!
email: anObject
	email := anObject! !

!SIUser methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:32'!
initialize


 super initialize.! !

!SIUser methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:32'!
password
	^ password! !

!SIUser methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:32'!
password: anObject
	password := anObject! !

!SIUser methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:32'!
userName
	^ userName! !

!SIUser methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:32'!
userName: anObject
	userName := anObject! !

Object subclass: #FancyString
	instanceVariableNames: 'stringRegisterOne stringRegisterTwo index length'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt-StringManipulation'!

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 14:20'!
inString: aString indexChar: aChar
	| num |
	(aString includes: aChar) ifFalse: [^0].
	num := 1.
	[(aString at: num) ~= aChar] whileTrue: [num := num + 1].
	^num.! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 14:00'!
index
	^ index! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 14:00'!
index: anObject
	index := anObject! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 15:50'!
isNonSpecialCharacter: aChar
	| usableSymbols |
	usableSymbols := '!!#$%&''*+-/=?^_`{|}~abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'.
	^usableSymbols includes: aChar.
	! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 16:57'!
isValidDomainString: aString
	|openBracket closeBracket|
	(aString size > 0) ifFalse: [^false].
	openBracket := aString first = $[.
	closeBracket := aString last = $].
	(openBracket xor: closeBracket) ifTrue: [^false].
	openBracket
	ifTrue:
		[(aString size > 2) ifFalse: [^false] ifTrue: [^self isValidIP: aString allButFirst allButLast ]]
	ifFalse:
		[^self isValidLocalString: aString].! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 16:59'!
isValidEmailAddress: aString
	(self splitString: aString at: $@) ifFalse: [^false].
	^((self isValidLocalString: (self stringRegisterOne)) and:
	(self isValidDomainString: (self stringRegisterTwo)))! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 16:49'!
isValidIP: aString
	^ self isValidIPv4: aString.! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 15:18'!
isValidIPv4: arbString
	| aString |
	aString := arbString copy.
	aString := aString, '.'.	
		Transcript cr;show: 'meep'.
	(self testIPv40to256: aString) ifFalse: [^false].
		Transcript show: 'meep'.
	(self testIPv40to256: self stringRegisterTwo) ifFalse: [^false].
		Transcript show: 'meep'.
	(self testIPv40to256: self stringRegisterTwo) ifFalse: [^false].
		Transcript show: 'meep'.
	(self testIPv40to256: self stringRegisterTwo) ifFalse: [^false].
		Transcript show: 'meep'.
	^ (self stringRegisterTwo) isEmpty.! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 16:45'!
isValidLocalString: aString
	| copyString newString |
	copyString := aString copy.
	(self isNonSpecialCharacter: copyString first) ifFalse: [^false].
	
	[copyString ~= ''] whileTrue: [
		Transcript cr;show:'BLASTOFF: ';show:copyString;cr.
		newString := self truncateNonSpecialCharacters: copyString.
		Transcript show:'BLASTOFF: ';show:newString;cr.
		((newString = copyString) or: (newString = '.')) ifTrue: [^false].
		copyString := newString.
		(copyString ~= '') ifTrue: [
			 ((copyString first) = $.) ifFalse: [^false] ifTrue: [copyString := copyString allButFirst]]].
	^true.
		! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 14:25'!
length
	^ length! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 14:25'!
length: anObject
	length := anObject! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 14:41'!
matchHeadOf: aString to: bString
	|aStringCopy bStringCopy|
	aStringCopy := aString copy.
	bStringCopy := bString copy.
	
	(aString size < bString size) ifTrue: [^false].
	
	[((aStringCopy first) = (bStringCopy first)) and: (bStringCopy size > 1)]
	whileTrue: [
		aStringCopy := aStringCopy allButFirst.
		bStringCopy := bStringCopy allButFirst].
	^(bStringCopy first = aStringCopy first).! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 14:30'!
splitString: aString at: aChar
	| num before after |
	num := self inString: aString indexChar: aChar.
	(num = 0) ifTrue: [^false].
	(num = 1) ifTrue: [
		self stringRegisterOne: ''.
		self stringRegisterTwo: aString allButFirst.
		^true].
	(num = aString size) ifTrue: [
		self stringRegisterOne: aString allButLast.
		self stringRegisterTwo: ''.
		^true].
	self stringRegisterOne: (aString copyFrom: 1 to: num-1).
	self stringRegisterTwo: (aString copyFrom: num+1 to: (aString size)).
	^true! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 14:25'!
stringRegisterOne
	^ stringRegisterOne! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 14:25'!
stringRegisterOne: anObject
	stringRegisterOne := anObject! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 14:25'!
stringRegisterTwo
	^ stringRegisterTwo! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 14:31'!
stringRegisterTwo: anObject
	stringRegisterTwo := anObject! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 15:18'!
testIPv40to256: aString
	| goodString checkString stringNumber |
	checkString := aString copy.
	checkString := '0', checkString.
	(goodString := self splitString: checkString at: $.) ifFalse: [^false].
	checkString := self stringRegisterOne copy.
	((stringNumber := checkString asNumber) asString = checkString allButFirst) ifFalse: [^false].
	^((stringNumber < 256) and: (stringNumber >= 0))! !

!FancyString methodsFor: 'accessing' stamp: 'JonathanBaca 2/11/2013 16:11'!
truncateNonSpecialCharacters: aString
	|  myIndex stringSize copyString |
	myIndex := 1.
	stringSize := aString size.
	copyString := aString copy, '.'.
	[(stringSize >= myIndex) and: (self isNonSpecialCharacter: (copyString at: myIndex))]
	whileTrue: [
		myIndex := myIndex + 1].
	(myIndex > stringSize) ifTrue: [^''].
	^copyString copyFrom: myIndex to: stringSize. ! !

Object subclass: #SIDatabase
	instanceVariableNames: 'connectionFailed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt'!

!SIDatabase methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:16'!
addUser: aUser

	self subclassResponsibility.! !

!SIDatabase methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:16'!
connect

	^ true! !

!SIDatabase methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:16'!
connectionFailed

	^ false! !

!SIDatabase methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:16'!
connectionFailed: aBoolean

	connectionFailed := aBoolean.! !

!SIDatabase methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:16'!
disconnect

	^ true! !

!SIDatabase methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:16'!
findUserByEmail: anEmail

	self subclassResponsibility.! !

!SIDatabase methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:16'!
initialize

	self connectionFailed: false! !

SIDatabase subclass: #SIImageDatabase
	instanceVariableNames: ''
	classVariableNames: 'Users WriteMutex'
	poolDictionaries: ''
	category: 'SqueakIt'!

!SIImageDatabase class methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:17'!
users
	
	^ Users ifNil: [Users := OrderedCollection new]! !

!SIImageDatabase class methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:17'!
users: anObject

	Users := anObject.! !

!SIImageDatabase class methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:17'!
writeMutex
	
	^ WriteMutex ifNil: [WriteMutex := Monitor new]! !

!SIImageDatabase class methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:17'!
writeMutex: anObject

	WriteMutex := anObject.! !

!SIImageDatabase methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:17'!
addUser: aUser

	self class users add: aUser.
	self saveImage.
	^ aUser! !

!SIImageDatabase methodsFor: 'actions' stamp: 'BiancaBologa 2/10/2013 16:17'!
disconnect! !

!SIImageDatabase methodsFor: 'accessing' stamp: 'BiancaBologa 2/10/2013 16:17'!
findUserByEmail: anEmail

	^ self class users
		detect: [:each | each email = anEmail]
		ifNone: [nil]! !

!SIImageDatabase methodsFor: 'actions' stamp: 'BiancaBologa 2/10/2013 16:17'!
save: anObject
	
	self saveImage.! !

!SIImageDatabase methodsFor: 'actions' stamp: 'BiancaBologa 2/10/2013 16:17'!
saveImage

	self class writeMutex critical: [self saveImageWithoutMonitor].! !

!SIImageDatabase methodsFor: 'actions' stamp: 'BiancaBologa 2/10/2013 16:17'!
saveImageWithoutMonitor

	SmalltalkImage current saveSession.! !

SIDatabase subclass: #SISandstoneDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakIt'!

!SISandstoneDatabase class methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:35'!
initialize

	| class |
	class := Smalltalk classNamed: #SDActiveRecord.
	class ifNotNil: [class warmUpAllClasses].! !

!SISandstoneDatabase methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:35'!
addUser: aUser

	aUser save. 
	^ aUser! !

!SISandstoneDatabase methodsFor: 'as yet unclassified' stamp: 'BiancaBologa 2/10/2013 16:35'!
findUserByEmail: aString 

	^ SIUser find: [ :each | each email = aString]! !
SIRootTask initialize!
SISandstoneDatabase initialize!
